import PyQt4.QtCore
import PyQt4.QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

import re

import Constants

class ParentHolder (PyQt4.QtGui.QLineEdit):
	def __init__ (self, bridge, inList, outList = []):
		PyQt4.QtGui.QLineEdit.__init__ (self, "None")
		self._bridge = bridge
		self._item = None
		self.setReadOnly (True)
		self.setAcceptDrops (True)
		self._inList = []
		self._outList = []

		self.layout = PyQt4.QtGui.QGridLayout ()
		if outList == []:
			self.layout.addWidget (PyQt4.QtGui.QLabel (self._typeDisplay + ": "), \
				0, 0, PyQt4.QtCore.Qt.AlignRight)
			self.layout.addWidget (self, 0, 1, PyQt4.QtCore.Qt.AlignLeft)
		else:
			self.layout.addWidget (PyQt4.QtGui.QLabel (self._typeDisplay + ": "), \
				0, 0, 1, 2, PyQt4.QtCore.Qt.AlignRight)
			self.layout.addWidget (self, 0, 2, 1, 2, PyQt4.QtCore.Qt.AlignLeft)

		count = 0
		for inStr in inList:
			self._inList.append (ChildAttributeHolder (bridge, self))
			self.layout.addWidget (PyQt4.QtGui.QLabel (str (inStr) + ": "), \
				(count + 1), 0, PyQt4.QtCore.Qt.AlignRight)
			self.layout.addWidget (self._inList[count], (count + 1), 1, PyQt4.QtCore.Qt.AlignLeft)
			count += 1

		count = 0
		for outStr in outList:
			self._outList.append (OutputHolder (str (outStr), bridge))
			self.layout.addWidget (PyQt4.QtGui.QLabel (str (outStr) + ": "), \
				(count + 1), 2, PyQt4.QtCore.Qt.AlignRight)
			self.layout.addWidget (self._outList[count], (count + 1), 3, PyQt4.QtCore.Qt.AlignLeft)
			count += 1

	def isInFull (self):
		if len (self._inList) == self.getNumberOfIns ():
			return True
		return False

	def getNumberOfIns (self):
		result = 0
		for holder in self._inList:
			if holder._item:
				result += 1
		return result

	def getInNames (self, careful = True):
		result = []
		for holder in self._inList:
			if holder._item:
				result.append (holder.text ())
			elif careful == True:
				return False
		return result

	def getInAccesses (self, careful = True):
		result = []
		for holder in self._inList:
			if holder._item:
				result.append (holder._item._shellAccess)
			elif careful == True:
				return False
		return result

	def getOutNames (self, careful = True):
		result = []
		for holder in self._outList:
			if holder.text () != "":
				result.append (holder.text ())
			elif careful == True:
				return False
		return result

	def clear (self):
		self.setText ("None")
		self._item = None

	def SetItem (self, item, clobber = True):
		if item.Type () == self._type and ((clobber == False and self._item != None) \
		or clobber == True):
			self._item = item
			self.setText (item._name)
			self._shellAccess = item._shellAccess
			self.PurgeIncorrectChildren ()

	def PurgeIncorrectChildren (self):
		for holder in self._inList:
			if holder._item and holder._item.parent ()._shellAccess != self._item._shellAccess:
				holder.clear ()

	def dropEvent (self, ev):
		if ev.mimeData ().hasFormat ("text/plain"):
			data = self._bridge.PopDrugItem ()
			if data.Type () == "ALIAS":
				data = data._item
			if data.Type () == self._type:
				self.SetItem (data, clobber = True)
				self.setFocus ()

				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
		else:
			ev.ignore ()

     	def dragEnterEvent (self, ev):
		if ev.mimeData ().hasFormat ("text/plain"):
			if ev.source () == self._bridge._regionViewer:
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
			else:
				ev.acceptProposedAction ()
		else:
			ev.ignore ()

class ParentListHolder (ParentHolder):
	def __init__ (self, bridge, inList, outList = []):
		self._type = "LIST"
		self._typeDisplay = "List"
		ParentHolder.__init__ (self, bridge, inList, outList)
		self.setStatusTip ("List Holder")
		self.setToolTip ("Place List Here")

class ParentGridHolder (ParentHolder):
	def __init__ (self, bridge, inList, outList = []):
		self._type = "GRID"
		self._typeDisplay = "Grid"
		ParentHolder.__init__ (self, bridge, inList, outList)
		self.setStatusTip ("Grid Holder")
		self.setToolTip ("Place Grid Here")

class ChildAttributeHolder (PyQt4.QtGui.QLineEdit):
	def __init__ (self, bridge, list):
		PyQt4.QtGui.QLineEdit.__init__ (self, "None")
		self._bridge = bridge
		self._list = list
		self._item = None
		self.setReadOnly (True)
		self.setAcceptDrops (True)
		self.setStatusTip ("Attribute Holder")
		self.setToolTip ("Place Attribute Here")

	def clear (self):
		self.setText ("None")
		self.setStatusTip ("Empty");
		self._item = None

	def SetItem (self, item, clobber = True):
		if item.Type () == "ATTRIBUTE" and (item.parent ().Type () == self._list._type \
		or self._list._type == "FREE")  and ((clobber == False and self._item == None) \
		or clobber == True):
			self._item = item
			self.setText (item._name)
			if self._list._item == None or \
			item.parent ()._shellAccess != self._list._item._shellAccess:
				self._list.SetItem (item.parent (), clobber = True)
				self.setStatusTip (makeBreadCrumb (item._shellAccess));
			# True signifies that an Item has been set, or cannot be set in the current condition
			return True
		elif item.Type () == "VALUE" and item._type == "_basin.Attribute" \
		and ((clobber == False and self._item == None) or clobber == True):
			if   self._list._type == "FREE" or self._list.isEnabled () == False:
				self._item = item
				self.setText (item._name)
				self.setStatusTip (makeBreadCrumb (item._shellAccess));
			else:
				self._list._bridge._statusBar.showTimed ("You cannot add this for an 'In Place' action...", STATUS_WAIT)
			# True signifies that an Item has been set, or cannot be set in the current condition
			return True
		# False signifies that it should continue looking for available holders
		return False

	def dropEvent (self, ev):
		# Get the drug item and then make sure something is indeed there
		data = self._bridge.PopDrugItem ()
		if not data:
			return
		if data.Type () == "ALIAS":
			data = data._item
		# If its already an attribute, go ahead and drop it
		if data.Type () == "ATTRIBUTE":
			self.SetItem (data, clobber = True)
			self.setFocus ()
			ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
			ev.accept ()
		# If its a free floating value, check to atleast make sure its a basin attribute
		elif data.Type () == "VALUE" and data._type == "_basin.Attribute":
			if   self._list._type == "FREE":
				self.SetItem (data, clobber = True)
				self.setFocus ()
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
			elif self._list.isEnabled () == False:
				self.SetItem (data, clobber = True)
				self.setFocus ()
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
			# otherwise just ignore the action
			else:
				self._bridge._statusBar.showTimed ("You may only drop attributes here!", STATUS_WAIT)
				ev.ignore ()
		# otherwise just ignore the action
		else:
			self._bridge._statusBar.showTimed ("You may only drop attributes here!", STATUS_WAIT)
			ev.ignore ()

     	def dragEnterEvent (self, ev):
		ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
		ev.accept ()

class ChildListHolder (PyQt4.QtGui.QLineEdit):
	def __init__ (self, bridge, parent):
		PyQt4.QtGui.QLineEdit.__init__ (self, "None")
		self._bridge = bridge
		self._item = None
		self._parent = parent
		self.setReadOnly (True)
		self.setAcceptDrops (True)
		self.setStatusTip ("List Holder")

	def clear (self):
		self.setText ("None")
		self.setStatusTip ("Empty");
		self._item = None

	def SetItem (self, item, clobber = True):
		if item.Type () == "VALUE" and item._type == "list" \
		and ((clobber == False and self._item == None) or clobber == True):
			if   self._parent._type == "FREE":
				self._item = item
				self.setText (item._name)
				self.setStatusTip (makeBreadCrumb (item._shellAccess));
			elif self._parent.isEnabled () == False:
				self._item = item
				self.setText (item._name)
				self.setStatusTip (makeBreadCrumb (item._shellAccess));
			# True signifies that an Item has been set, or cannot be set in the current condition
			return True
		# False signifies that it should continue looking for available holders
		return False

	def dropEvent (self, ev):
		# Get the drug item and then make sure something is indeed there
		data = self._bridge.PopDrugItem ()
		if not data:
			return
		if data.Type () == "ALIAS":
			data = data._item
		# If its a free floating value, check to atleast make sure its a basin attribute
		if data.Type () == "VALUE" and data._type == "list":
			if   self._parent._type == "FREE":
				self.SetItem (data, clobber = True)
				self.setFocus ()
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
			elif self._parent.isEnabled () == False:
				self.SetItem (data, clobber = True)
				self.setFocus ()
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
			# otherwise just ignore the action
			else:
				self._bridge._statusBar.showTimed ("You may only drop float lists here!", STATUS_WAIT)
				ev.ignore ()
		# otherwise just ignore the action
		else:
			self._bridge._statusBar.showTimed ("You may only drop float lists here!", STATUS_WAIT)
			ev.ignore ()

     	def dragEnterEvent (self, ev):
		ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
		ev.accept ()


class OutputHolder (PyQt4.QtGui.QLineEdit):
	def __init__ (self, default, bridge):
		PyQt4.QtGui.QLineEdit.__init__ (self, default)
		self._bridge = bridge
		self.setReadOnly (False)
		self.setAcceptDrops (False)
		self._default = default
		regexp = QRegExp ("[A-Za-z_][0-9A-Za-z_]*")
		valid = QRegExpValidator (regexp, self)
		self.setValidator (valid)
		self.setStatusTip ("Output")
		self.setToolTip ("Output Name")

	def clear (self):
		self.setText (self._default)


class FreeHolderGroup:
	def __init__ (self, bridge, inList, outList = []):
		self._bridge = bridge
		self._item = None
		self._inList = []
		self._outList = []
		self._type = "FREE"

		self.layout = PyQt4.QtGui.QGridLayout ()
		count = 0
		for inStr in inList:
			self._inList.append (ChildAttributeHolder (bridge, self))
			self.layout.addWidget (PyQt4.QtGui.QLabel (str (inStr) + ": "), count, 0, PyQt4.QtCore.Qt.AlignRight)
			self.layout.addWidget (self._inList[count], count, 1, PyQt4.QtCore.Qt.AlignLeft)
			count += 1

		count = 0
		for outStr in outList:
			self._outList.append (OutputHolder (str (outStr), bridge))
			self.layout.addWidget (PyQt4.QtGui.QLabel (str (outStr) + ": "), \
				count, 2, PyQt4.QtCore.Qt.AlignRight)
			self.layout.addWidget (self._outList[count], count, 3, PyQt4.QtCore.Qt.AlignLeft)
			count += 1

	def isInFull (self):
		if len (self._inList) == self.getNumberOfIns ():
			return True
		return False

	def getNumberOfIns (self):
		result = 0
		for holder in self._inList:
			if holder._item:
				result += 1
		return result

	def getInNames (self, careful = True):
		result = []
		for holder in self._inList:
			if holder._item:
				result.append (holder.text ())
			elif careful == True:
				return False
		return result

	def getInAccesses (self, careful = True):
		result = []
		for holder in self._inList:
			if holder._item:
				result.append (holder._item._shellAccess)
			elif careful == True:
				return False
		return result

	def getOutNames (self, careful = True):
		result = []
		for holder in self._outList:
			if holder.text () != "":
				result.append (holder.text ())
			elif careful == True:
				return False
		return result

	def clear (self):
		for holder in self._inList:
			holder.clear ()
		for holder in self._outList:
			holder.clear ()

	def SetItem (self, item, clobber = True):
		return

class GenericGroupHolder:
	def __init__ (self, bridge, parent, name, inputs, inputOrder, outputs):
		"""
		@param bridge: The bridge object which connects all interactive components together.
		@type bridge: L{Bridge<client.BASIN_bridge.Bridge>}

		@param parent: The first list contains strings of valid basin types. The second list contains
		               strings of valid python types. There must be exactly two outter lists, the inner
			       lists may vary from being empty to any number of strings.
		@type parent: [list <string>, list <string>]

		@param name: A string name of the parent
		@type name: 

		@param inputs: A dictionary of string names for inputs, to a 2 element list of lists, similar to
		               the type from `parent`
		@type inputs: [list <string>, list <string>] 

		@param inputOrder: A list of string names for inputs.  These should correspond to the keys of C{inputs}.
		@type inputOrder: list <string>

		@param outputs: A list of string names for outputs.
		@type outputs: list <string>
		"""
		self._layout = QVBoxLayout ()
		self._inputTypes = inputs
		self._inputHolders = []
		self._outputHolders = []

		topLayout = Constants.BQHBoxLayout (self._layout)
		bottomLayout = Constants.BQHBoxLayout (self._layout)

		self._parent = GenericInputHolder (bridge, topLayout, name, parent[0], parent[1])

		inputLayout = Constants.BQVBoxLayout (bottomLayout)
		for key in inputOrder:
			GenericChildHolder (bridge, self, inputLayout, key, inputs[key][0], inputs[key][1])

		outputLayout = Constants.BQVBoxLayout (bottomLayout)
		count = 0
		for output in outputs:
			tempLayout = Constants.BQHBoxLayout (outputLayout)
			tempLabel = PyQt4.QtGui.QLabel (output + ":")
			tempLabel.setAlignment (PyQt4.QtCore.Qt.AlignVCenter | PyQt4.QtCore.Qt.AlignRight)
			tempLayout.addWidget (tempLabel)
			self._outputHolders.append (OutputHolder (str (output), bridge))
			tempLayout.addWidget (self._outputHolders[count])
			count += 1

	def setEnabled (self, enable):
		"""
		Overview
		========
		This method allows you to switch make the group's parent holder usable or unusable.  This can be
		useful when you want to be able to "switch" between a group of holders with a parent, and without.

		An example of this is in the L{AbstractTransform<client.Dock.Transforms.AbstractTransform>} where
		a checkbox is used to determine if the function's output should be directed to the parent list
		(in which case we'd want this function to enable the parent holder).  Otherwise the function
		will direct its output to the free variables (in which case we'd want the function to disable
		the parent holder).

		@param enable: If true, will allow the group's parent holder to be accessable, false if not.
		@type enable: boolean

		return: none
		"""

		self._parent.setEnabled (enable)

	def isInFull (self):
		"""
		Overview
		========
		This method will return either True or False depending on whether all of the input holders have
		been filled in.

		It utilizes L{getNumberOfIns<client.Dock.Holders.GenericGroupHolder.getNumberOfIns>} and compares
		it to the length of self._inputHolders.

		@return: boolean, whether or not all of the input holders have been filled
		"""
		if len (self._inputHolders) == self.getNumberOfIns ():
			return True
		return False

	def getNumberOfIns (self):
		"""
		Overview
		========
		This method will returnthe number of input holders which have a _item member.  The method does not
		take in to account the total number of holders.

		@return: integer, the number of items found in the input holders
		"""
		result = 0
		for holder in self._inputHolders:
			if holder._item:
				result += 1
		return result

	def getInNames (self, careful = True):
		"""
		GenericGroupHolder.getInNames (self, careful = True)

		This method will generalls return a list of the names
		on items in the input holders.

		If careful is True, then it will return False if it ever
		encounters an empty holder.  It defaults to this.

		If careful is False, then it will always return a list
		of strings, and if an input holder has no _item member,
		then it won't append anything to the result list.
		"""
		result = []
		for holder in self._inputHolders:
			if holder._item:
				result.append (holder.text ())
			elif careful == True:
				return False
		return result

	def getInAccesses (self, careful = True):
		"""
		GenericGroupHolder.getInAccesses (self, careful = True)

		This method will generalls return a list of the ipython
		shell access strings on items in the input holders.

		If careful is True, then it will return False if it ever
		encounters an empty holder.  It defaults to this.

		If careful is False, then it will always return a list
		of strings, and if an input holder has no _item member,
		then it won't append anything to the result list.
		"""
		result = []
		for holder in self._inputHolders:
			if holder._item:
				result.append (holder._item._shellAccess)
			elif careful == True:
				return False
		return result

	def getOutNames (self, careful = True):
		"""
		GenericGroupHolder.getOutNames (self, careful = True)

		This method will generalls return a list of the names
		on items in the output holders.

		If careful is True, then it will return False if it ever
		encounters an empty holder.  It defaults to this.

		If careful is False, then it will always return a list
		of strings, and if an output holder has no _item member,
		then it won't append anything to the result list.
		"""
		result = []
		for holder in self._outputHolders:
			if holder.text () != "":
				result.append (holder.text ())
			elif careful == True:
				return False
		return result

	def clear (self):
		"""
		Overview
		========
		This is a convenience method which simply calls the C{clear ()} method on:
		 1. C{self._parent}
		 2. all holders in C{self._inputHolders}
		 3. all holders in C{self._outputHolders}

		return: none
		"""

		self._parent.clear ()
		for holder in self._inputHolders:
			holder.clear ()
		for holder in self._outputHolders:
			holder.clear ()

	def PurgeIncorrectChildren (self):
		"""
		Overview
		========
		This method will run through all of the input holders and check if their parent item is the
		current parent item.  If any of the input holders don't meet that condition, then their clear
		method is called individually, effectively purging it from the group.

		return: none
		"""

		for holder in self._inputHolders:
			if holder._item and holder._item.parent ()._shellAccess != self._parent._shellAccess:
				holder.clear ()


class GenericInputHolder (PyQt4.QtGui.QLineEdit):
	def __init__ (self, bridge, parentLayout, name, basinTypes, pythonTypes):
		PyQt4.QtGui.QLineEdit.__init__ (self, "None")
		self._bridge = bridge
		self._item = None
		self._name = name
		self._size = None
		self._type = None
		self._basinTypes = basinTypes
		self._pythonTypes = pythonTypes
		self.setReadOnly (True)
		self.setAcceptDrops (True)

		layout = Constants.BQHBoxLayout (parentLayout)
		label = PyQt4.QtGui.QLabel (self._name + ":")
		label.setAlignment (PyQt4.QtCore.Qt.AlignVCenter | PyQt4.QtCore.Qt.AlignRight)
		layout.addWidget (label)
		layout.addWidget (self)

	def type (self):
		# No sense in going through a server command if its already been done
		if self._type:
			return self._type

		result = self._bridge._ipyShell.SilentCommand ("print \"\\n\" + str (type (" + \
			self._item._shellAccess + "))", False)
		result = result.split ("\n")[3]

		# Save and return result
		self._type = result
		return self._type

	def size (self):
		# No sense in going through a server command if its already been done
		if self._size:
			return self._size

		result = ""
		type = self.type ()
		if   type == "<type 'list'>":
			result = self._bridge._ipyShell.SilentCommand ("print \"\\n\" + str (len (" + \
				self._item._shellAccess + "))").split ("\n")[3]
		elif type == "<class '_basin.Attribute'>":
			result = self._bridge._ipyShell.SilentCommand ("print \"\\n\" + str (len (" + \
				self._item._shellAccess + ".get_dims ()))").split ("\n")[3]
		self._size = int (result)
		return self._size

	def clear (self):
		self.setText ("None")
		self._item = None
		self._type = None
		self._size = None
		self.setStatusTip ("Empty")

	def SetItem (self, item, clobber = True):
		for type in self._basinTypes:
			if item.Type () == type and ((clobber == False and self._item == None) \
			or clobber == True):
				self._item = item
				self._type = None
				self._size = None
				self.setText (item._name)
				self.setStatusTip (makeBreadCrumb (self._item._shellAccess));
				# True signifies that an Item has been set, or cannot be set in the current condition
				return True

		for type in self._pythonTypes:
			if item.Type () == "VALUE" and item._type == type \
			and ((clobber == False and self._item == None) or clobber == True):
				self._item = item
				self._type = None
				self._size = None
				self.setText (item._name)
				self.setStatusTip (makeBreadCrumb (self._item._shellAccess));
				# True signifies that an Item has been set, or cannot be set in the current condition
				return True

		# False signifies that it should continue looking for available holders
		return False

	def dropEvent (self, ev):
		# Get the drug item and then make sure something is indeed there
		data = self._bridge.PopDrugItem ()
		if not data:
			return
		if data.Type () == "ALIAS":
			data = data._item

		# Attempt to add the data of any valid basin types
		for type in self._basinTypes:
			if data.Type () == type:
				self.SetItem (data, clobber = True)
				self.setFocus ()
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
				return
				
		# Attempt to add the data of any valid python types
		for type in self._pythonTypes:
			if data.Type () == "VALUE" and data._type == type:
				self.SetItem (data, clobber = True)
				self.setFocus ()
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
				return

		self._bridge._statusBar.showTimed ("You may not drop that type here!", Constants.STATUS_WAIT)
		ev.ignore ()

     	def dragEnterEvent (self, ev):
		ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
		ev.accept ()


class GenericChildHolder (GenericInputHolder):
	"""
	Overview
	========
	This class of objects is a simple addition to L{GenericInputHolders<GenericInputHolder>} such that it
	will also contain a reference to a parent.  This is so that a group holder may contain children holders
	and the children holders are aware that they have a parent.
	"""
	def __init__ (self, bridge, parent, parentLayout, name, basinTypes, pythonTypes):
		"""
		@param bridge: The interlinking bridge class.
		@type bridge: L{Bridge<client.Bridge>}

		@param parent: This is the group holder which will own this holder.
		@type parent: L{GenericGroupHolder<GenericGroupHolder>}

		@param parentLayout: The layout of the parent for which this holder will be inserted into.
		@type parentLayout: PyQt4.QtGui.QLayout

		@param name: This will be the name of the holder, signified by a PyQt4.QtGui.QLabel.
		@type name: string

		@param basinTypes: This strings in this list are the allowable Basin types that this holder will be
		                   able to take as input.  They are one of these:
				     - "REGION"
				     - "GRID"
				     - "LIST"
				     - "ATTRIBUTE"
		@type basinTypes: list <string>

		@param pythonTypes: The strings in this list are the allowable python types that this holder will be
		                    able to take as input.  Calling the global python function I{type (object)} on an
				    object will show you the string for the object's type.
				    (Generally module_name.class_name)
		@type pythonTypes: list <string>
		"""

		GenericInputHolder.__init__ (self, bridge, parentLayout, name, basinTypes, pythonTypes)
		self._parent = parent._parent
		parent._inputHolders.append (self)


class NameHolder (PyQt4.QtGui.QLineEdit):
	"""
	Overview
	========
	This holder is a simple implementation of a PyQt4.QtGui.QLineEdit which has a default value.  The purpose of the default
	value is that when the holder is cleared, instead of an empty string the default value appears.  This is used
	for the naming of data which has yet to be created.  In that sense the NameHolder is different from other
	holders since it doesn't represent data, just a name for future data.
	"""

	def __init__ (self, text):
		"""
		Overview
		========
		This simple constructor will create a PyQt4.QtGui.QLineEdit and set its default value and initial value.
		
		@param text: This will become the initial text of the PyQt4.QtGui.QLineEdit, as well as the default value for it.
		@type text: string
		"""

		PyQt4.QtGui.QLineEdit.__init__ (self, text)
		self._default = text

	def clear (self):
		"""
		Overview
		========
		This overrides the normal implementation of clear so that instead of setting its text to an empty
		string, it is reset to the default value.
		"""

		self.setText (self._default)

	def dropEvent (self, ev):
		"""
		Overview
		========
		This method handles the dropping of objects into the PyQt4.QtGui.QLineEdit.  It will essentially take the displayed
		name of objects from the basin object tree and set the text of the PyQt4.QtGui.QLineEdit to that.

		@param ev: This is the event object for dropping an object into the PyQt4.QtGui.QLineEdit.  It must have a mime data
		           type that is plain text.
		@type ev: QDropEvent
		"""

		if ev.mimeData ().hasFormat ("text/plain"):
			data = self._bridge.PopDrugItem ()
			if data != None:
				self.setText (data._name)
				ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
				ev.accept ()
		else:
			ev.ignore ()

     	def dragEnterEvent (self, ev):
		"""
		Overview
		========
		This method simply allows objects to be dragged over the PyQt4.QtGui.QLineEdit.  Without the ability to be drug over
		this object, an object could not be dropped into it.

		@param ev: 
		@type ev: QDragEnterEvent
		"""

		ev.setDropAction (PyQt4.QtCore.Qt.LinkAction)
		ev.accept ()


def makeBreadCrumb (text):
	"""
	Overview
	========
	This function will take the shell access from an abstract basin object (from the Basin Objects tree) and transform it into a more readable bread crumb string.  This is useful since the name displayed in a holder is not necessarily unique, however, the bread crumb of any object is unique.  Currently this is taken and displayed in the Status Bar, but this function doesn't take care of that.

	@param text: This is a string that must be in the form of a the _shellAccess variable of an abstract
	             basin object from the basin object tree.  The format of it will not be verified, and no
		     errors should arise if it is not of that format, but the return will be meaningless.
	@type text: string

	@return: string
	"""

	return "Region: " + text.replace ("get_attribute", " - Attribute:").replace ("get_list", " - List:").replace ("get_grid", " - Grid:").replace ("get_child", " - Region:").replace (".", "").replace ("(", "").replace (")", "").replace ("\"", "")

